PROGRAM Ct_Benchmark;

{$N+,E-}
{$M 65500,0,600000}
{$D-,Y-,L-}
{Bemerkungen : siehe ct.pas}

USES Crt,Dos,Graph;

TYPE
  Computertyp = RECORD
    Name : STRING[30];
    Ganzzahl : double;
    Realzahl : double;
    Trig     : double;
    Textscrn : double;
    Grafscrn : double;
    Storec   : double;
  END;


CONST Max1 =17;
      Space='                   ';

      Vergleich : ARRAY [1..Max1] OF Computertyp =(
      (Name: '8086/ 87 8 Mhz   '; Ganzzahl :0.66; Realzahl: 4.02; Trig: 1.10; Textscrn: 24.44; Grafscrn: 1.75; Storec: 1.25),
      (Name: 'V-30/ 87 8 Mhz   '; Ganzzahl :0.33; Realzahl: 3.73; Trig: 1.05; Textscrn: 21.42; Grafscrn: 1.59; Storec: 1.25),
      (Name: 'Macintosh II     '; Ganzzahl :0.10; Realzahl: 6.15; Trig: 7.68; Textscrn: 44.83; Grafscrn: 5.20; Storec: 1.06),
      (Name: 'i386 / i 387     '; Ganzzahl :0.0264; Realzahl: 0.154; Trig: 0.01003; Textscrn: 10.86; Grafscrn: 0.60;
      Storec: 0.8),
      (Name: '486 DLC / i387   '; Ganzzahl :0.0159; Realzahl: 0.1248; Trig: 0.078; Textscrn: 9.5; Grafscrn: 0.6;
      Storec: 0.8),
      (Name: '486 DX 33 Mhz    '; Ganzzahl :0.0176; Realzahl: 0.0445; Trig: 0.1280; Textscrn: 3.13; Grafscrn: 0.280;
      Storec: 0.116),
      (Name: '486 DX 50 Mhz    '; Ganzzahl :0.0121; Realzahl: 0.0380; Trig: 0.060; Textscrn: 1.93; Grafscrn: 0.137;
      Storec: 0.164),
      (Name: '486 DX 50 Mhz VLB'; Ganzzahl :0.0131; Realzahl: 0.0330; Trig: 0.082; Textscrn: 1.21; Grafscrn: 0.121;
      Storec: 0.204),
      (Name: '486 DX/4 100 Mhz '; Ganzzahl :0.0065; Realzahl: 0.017; Trig: 0.038; Textscrn: 2.14; Grafscrn: 0.082;
      Storec: 0.055),
      (Name: 'AM586 p75 150 VLB'; Ganzzahl :0.0044; Realzahl: 0.011; Trig: 0.027; Textscrn: 2.31; Grafscrn: 0.054;
      Storec: 0.176),
      (Name: 'AM586 p75 133 PCI'; Ganzzahl :0.0049; Realzahl: 0.011; Trig: 0.027; Textscrn: 1.38; Grafscrn: 0.061;
      Storec: 0.093),
      (Name: 'Dell Pentium 575 '; Ganzzahl :0.0083; Realzahl: 0.011; Trig: 0.044; Textscrn: 1.71; Grafscrn: 0.099;
      Storec: 0.126),
      (Name: 'Dell Pentium 590 '; Ganzzahl :0.0066; Realzahl: 0.011; Trig: 0.016; Textscrn: 1.43; Grafscrn: 0.077;
      Storec: 0.028),
      (Name: 'Vobis Pentium 90 '; Ganzzahl :0.0099; Realzahl: 0.017; Trig: 0.022; Textscrn: 1.76; Grafscrn: 0.104;
      Storec: 0.038),
      (Name: 'Thinkpad 365-P100'; Ganzzahl :0.0057; Realzahl: 0.0105; Trig: 0.033; Textscrn: 5.08; Grafscrn: 0.069;
      Storec: 0.033),
      (Name: 'Media Markt P150 '; Ganzzahl :0.0044; Realzahl: 0.006; Trig: 0.016; Textscrn: 1.49; Grafscrn: 0.044;
      Storec: 0.017),
      (Name: 'Lion AMD K6/2-350'; Ganzzahl :0.00083; Realzahl: 0.0022; Trig: 0.00305; Textscrn: 1.49; Grafscrn: 0.033;
      Storec: 0.011)
      );

VAR I                           : Byte;
      C                           : Char;
      Index,Len,Mips,Mflops       : double;
      Ti,Tr,Tt,Ts,Tg,Tc,Ta,Tb,A,B : double;


FUNCTION Timer : double;

VAR H,M,S,Ss : Word;

BEGIN
  Gettime(H,M,S,Ss);
  Timer:=H*3600+M*60+S+Ss/100;
END;

PROCEDURE Intmath; {Orginal ct 10/87 n=10.000}

VAR   I,J : Integer;
      X,Y : Integer;

CONST Scale = 10000; {Konstante zum Skalieren auf moderne Prozessoren}

BEGIN
  X:=0;
  Y:=3;
  WriteLn('Starte Integermathematiktest...');
  A:=Timer;
  FOR I:=1 TO 10000 DO
  FOR J:=1 TO Scale DO
  BEGIN
    X:=X+(Y*Y-Y) DIV Y;
  END;
  Ti:=Timer-A;
  A:=Timer;
  FOR I:=1 TO 10000 DO
  FOR J:=1 TO Scale DO ;
  A:=Timer-A;
  Mips:=(0.07*Scale)/(Ti-A);
  WriteLn('Finish ',X);
  Ti:=Ti/Scale;
END;

PROCEDURE Realmath; {n=10.000}

VAR X,Y : double;
    I,J : Integer;

CONST Scale = 10000; {Konstante zum Skalieren auf moderne Prozessoren}

BEGIN
  X:=0.0;
  Y:=9.9;
  WriteLn('Starte Flieskommamathematiktest...');
  A:=Timer;
  FOR J:=1 TO Scale DO
  FOR I:=1 TO 10000 DO X:=X+(Y*Y-Y) / Y;
  Tr:=(Timer-A);
  WriteLn('Finish ',X/scale:10:4,'=89000 ?');
  A:=Timer;
  FOR J:=1 TO Scale DO
  FOR I:=1 TO 10000 DO ;
  A:=(Timer-A);
  Mflops:=(Scale*0.04)/(Tr-A);
  Tr:=Tr/Scale;
END;

PROCEDURE Trilog; {n=1000}


VAR X,Y : double;
      I,J : Integer;

CONST Scale = 1000; {Konstante zum Skalieren auf moderne Prozessoren}

BEGIN
  X:=0.0;
  Y:=9.9;
  WriteLn('Starte Trigonometrietest....');
  A:=Timer;
  FOR I:=1 TO 1000 DO
  FOR J:=1 TO Scale DO X:=X+Sin(ArcTan(Cos(Ln(Y))));
  Tt:=(Timer-A)/Scale;
  WriteLn('Finish ',X);
END;

PROCEDURE Textscreen; {N=1000}

VAR  I : Integer;

BEGIN
  WriteLn('Starte Bildschrimtest....');
  DirectVideo:=True; CheckSnow:=False;
  A:=Timer;
  FOR I:=1 TO 1000 DO WriteLn('1234567890qwertzuiop',I);
  Ts:=Timer-A;
  WriteLn('Finish');
END;

PROCEDURE Graphscreen; {N=100 x 100}

VAR X,Y : Integer;

BEGIN
  WriteLn('Starte Grafiktest....'); X:=Vga; Y:=Vgahi;
  InitGraph(X,Y,'');
  A:=Timer;
  FOR X:=1 TO 400 DO
  FOR Y:=1 TO 250 DO PutPixel(X,Y,1);
  Tg:=(Timer-A)/10;
  CloseGraph;
  WriteLn('Finish');
END;

PROCEDURE Store; {n=1000}

VAR I : Integer;
      X : STRING[60];
      T : Text;
      F : FILE;
      Drive : STRING[80];

BEGIN
  IF ParamCount>0 THEN Drive:=ParamStr(1) ELSE Drive:='';
  WriteLn('Starte Disktest...' );
  X:='123456789012345678901234567890123456789012345678901234567890';
  A:=Timer;
  Assign(T,Drive+'TEST.$$$');
  Rewrite(T);
  FOR I:=1 TO 10000 DO Write(T,X);
  Close(T);
  Tc:=(Timer-A)/10;
  Assign(F,Drive+'TEST.$$$');
  Reset(F,1);
  Len:=FileSize(F)/10240/Tc;
  WriteLn('Finish');
  Erase(T);
END;


BEGIN
  TextMode(3);
  Graphscreen;
  Intmath;
  Realmath;
  Trilog;
  Textscreen;
  Store;
  TextMode(3+Font8X8);
  WriteLn('C''T'' Benchmarktest 10/1987');
  WriteLn('Spezielle Ausgabe fr 80x87 Coprozessor');
  WriteLn;
  CASE Test8086 OF
    0 : WriteLn('Prozessor : 8086');
    1 : WriteLn('Prozessor : 80286');
    2 : WriteLn('Prozessor : 80386 oder hher');
  END;
  CASE Test8087 OF
    0 : WriteLn('Kein Coprozessor gefunden');
    1 : WriteLn('Coprozessor : 8087');
    2 : WriteLn('Coprozessor : 80287');
    3 : WriteLn('Coprozessor : 80387 oder hher');
  END;
  WriteLn;
  WriteLn('Intmath     ',Ti:12:5,' Sec (entspricht : ',Mips:5:2,' Mips)');
  WriteLn('Realmath 87 ',Tr:12:5,' Sec (entspricht : ',Mflops:5:2,' MFlops)');
  WriteLn('Trilog   87 ',Tt:12:5,' Sec');
  WriteLn('Textscreen  ',Ts:12:5,' Sec (entspricht : ',23000/Ts:8:0,' Zeichen/sec)');
  WriteLn('Graphscreen ',Tg:12:5,' Sec (entspricht : ',10000/Tg:8:0,' Pixels/sec)');
  WriteLn('Store       ',Tc:12:5,' Sec (entspricht : ',Len:8:2,' Kbytes/sec)');
  WriteLn;
  WriteLn('Typ                  Integer Realzahl Trilog  Text   Grafik  Speichern  Index');
  WriteLn('');
  FOR I:=1 TO Max1 DO
  WITH Vergleich[I] DO
  BEGIN
    Index:=(Ganzzahl/Ti)+(Realzahl/Tr)+(Trig/Tt)+(Textscrn/Ts)+(Grafscrn/Tg)+(Storec/Tc);
    WriteLn(Copy(Name+Space,1,20),Ganzzahl:8:4,Realzahl:8:3,Trig:8:3,Textscrn:7:2,Grafscrn:8:3,Storec:8:3,Index/6:7:2);
  END;
END.
